// ThreadUserInfo.cpp : Implementation of CThreadUserInfo
#include "stdafx.h"
#include "Userinfo.h"
#include "ThreadUserInfo.h"
#include "UserTranslate.h"

/////////////////////////////////////////////////////////////////////////////
// CThreadUserInfo


STDMETHODIMP CThreadUserInfo::getLogonName(BSTR *pVal)
{
	TCHAR uname[128] = {0};
	DWORD dwSize = 127;

	if(!GetUserName(uname, &dwSize)) return HRESULT_FROM_WIN32(GetLastError());

	_bstr_t bname(uname);
	*pVal = bname.copy();

	return S_OK;
}

STDMETHODIMP CThreadUserInfo::getDisplayName(BSTR *pVal)
{
	_bstr_t bname;

	HRESULT hResult = _getUserNameEx(NameDisplay, bname);
	if(hResult != S_OK) return hResult;

	*pVal = bname.copy();

	return S_OK;
}

STDMETHODIMP CThreadUserInfo::getFullyQualifiedDN(BSTR *pVal)
{
	_bstr_t bname;

	HRESULT hResult = _getUserNameEx(NameFullyQualifiedDN, bname);
	if(hResult != S_OK) return hResult;

	*pVal = bname.copy();

	return S_OK;
}

STDMETHODIMP CThreadUserInfo::getSAMCompatibleName(BSTR *pVal)
{
	_bstr_t bname;

	HRESULT hResult = _getUserNameEx(NameSamCompatible, bname);
	if(hResult != S_OK) return hResult;

	*pVal = bname.copy();

	return S_OK;
}

STDMETHODIMP CThreadUserInfo::getCanonicalName(BSTR *pVal)
{
	_bstr_t bname;

	HRESULT hResult = _getUserNameEx(NameCanonical, bname);
	if(hResult != S_OK) return hResult;

	*pVal = bname.copy();

	return S_OK;
}

STDMETHODIMP CUserTranslate::getDisplayBySAM(BSTR logon, BSTR *pVal)
{
	_bstr_t bname(logon);


	HRESULT hResult = _translateName(NameSamCompatible, NameDisplay, 
		logon, bname);

LPVOID lpMsgBuf;
FormatMessage( 
    FORMAT_MESSAGE_ALLOCATE_BUFFER | 
    FORMAT_MESSAGE_FROM_SYSTEM | 
    FORMAT_MESSAGE_IGNORE_INSERTS,
    NULL,
    GetLastError(),
    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
    (LPTSTR) &lpMsgBuf,
    0,
    NULL 
);

//bname = (LPCTSTR)lpMsgBuf;
// Free the buffer.
LocalFree( lpMsgBuf );

	*pVal = bname.copy();

	return S_OK;

	*pVal = bname.copy();

	if(hResult != S_OK) return hResult;

	*pVal = bname.copy();

	return S_OK;
}

HRESULT CThreadUserInfo::_getUserNameEx(EXTENDED_NAME_FORMAT exNameFormat, _bstr_t &name)
{
	TCHAR uname[255] = {0};
	DWORD dwSize = 254;

	if(!GetUserNameEx(exNameFormat, uname, &dwSize)) 
		return HRESULT_FROM_WIN32(GetLastError());

	name = uname;

	return S_OK;
}

HRESULT CUserTranslate::_translateName(EXTENDED_NAME_FORMAT fromFormat, 
										EXTENDED_NAME_FORMAT toFormat, 
										_bstr_t in, _bstr_t &out)
{
	wchar_t uname[255] = {0};
	DWORD dwSize = 254;

	if(!TranslateName(in, fromFormat, toFormat, uname, &dwSize)) 
		return HRESULT_FROM_WIN32(GetLastError());

	out = uname;

	return S_OK;
}

STDMETHODIMP CThreadUserInfo::getLastErrorText(BSTR *pVal)
{
	LPVOID lpMsgBuf;

	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER | 
		FORMAT_MESSAGE_FROM_SYSTEM | 
		FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL,
		GetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
		(LPTSTR) &lpMsgBuf,
		0,
		NULL 
	);

	_bstr_t bname((LPCTSTR) lpMsgBuf);

	LocalFree( lpMsgBuf );

	*pVal = bname.copy();

	return S_OK;
}
