// ThreadUserInfo.h : Declaration of the CThreadUserInfo

#ifndef __THREADUSERINFO_H_
#define __THREADUSERINFO_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CThreadUserInfo
class ATL_NO_VTABLE CThreadUserInfo : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CThreadUserInfo, &CLSID_ThreadUserInfo>,
	public IDispatchImpl<IThreadUserInfo, &IID_IThreadUserInfo, &LIBID_USERINFOLib>
{
public:
	CThreadUserInfo()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_THREADUSERINFO)
DECLARE_NOT_AGGREGATABLE(CThreadUserInfo)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CThreadUserInfo)
	COM_INTERFACE_ENTRY(IThreadUserInfo)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IThreadUserInfo
public:
	STDMETHOD(getLastErrorText)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(getCanonicalName)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(getSAMCompatibleName)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(getFullyQualifiedDN)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(getDisplayName)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(getLogonName)(/*[out, retval]*/ BSTR *pVal);
protected:
	HRESULT _getUserNameEx(EXTENDED_NAME_FORMAT exNameFormat, _bstr_t &name);
};

#endif //__THREADUSERINFO_H_
